]> git.proxmox.com Git - mirror_ubuntu-bionic-kernel.git/blob - scripts/decodecode
x86/msr-index: Cleanup bit defines
[mirror_ubuntu-bionic-kernel.git] / scripts / decodecode
1 #!/bin/sh
2 # SPDX-License-Identifier: GPL-2.0
3 # Disassemble the Code: line in Linux oopses
4 # usage: decodecode < oops.file
5 #
6 # options: set env. variable AFLAGS=options to pass options to "as";
7 # e.g., to decode an i386 oops on an x86_64 system, use:
8 # AFLAGS=--32 decodecode < 386.oops
9
10 cleanup() {
11 rm -f $T $T.s $T.o $T.oo $T.aa $T.dis
12 exit 1
13 }
14
15 die() {
16 echo "$@"
17 exit 1
18 }
19
20 trap cleanup EXIT
21
22 T=`mktemp` || die "cannot create temp file"
23 code=
24
25 while read i ; do
26
27 case "$i" in
28 *Code:*)
29 code=$i
30 ;;
31 esac
32
33 done
34
35 if [ -z "$code" ]; then
36 rm $T
37 exit
38 fi
39
40 echo $code
41 code=`echo $code | sed -e 's/.*Code: //'`
42
43 width=`expr index "$code" ' '`
44 width=$((($width-1)/2))
45 case $width in
46 1) type=byte ;;
47 2) type=2byte ;;
48 4) type=4byte ;;
49 esac
50
51 disas() {
52 ${CROSS_COMPILE}as $AFLAGS -o $1.o $1.s > /dev/null 2>&1
53
54 if [ "$ARCH" = "arm" ]; then
55 if [ $width -eq 2 ]; then
56 OBJDUMPFLAGS="-M force-thumb"
57 fi
58
59 ${CROSS_COMPILE}strip $1.o
60 fi
61
62 if [ "$ARCH" = "arm64" ]; then
63 if [ $width -eq 4 ]; then
64 type=inst
65 fi
66
67 ${CROSS_COMPILE}strip $1.o
68 fi
69
70 ${CROSS_COMPILE}objdump $OBJDUMPFLAGS -S $1.o | \
71 grep -v "/tmp\|Disassembly\|\.text\|^$" > $1.dis 2>&1
72 }
73
74 marker=`expr index "$code" "\<"`
75 if [ $marker -eq 0 ]; then
76 marker=`expr index "$code" "\("`
77 fi
78
79 touch $T.oo
80 if [ $marker -ne 0 ]; then
81 echo All code >> $T.oo
82 echo ======== >> $T.oo
83 beforemark=`echo "$code"`
84 echo -n " .$type 0x" > $T.s
85 echo $beforemark | sed -e 's/ /,0x/g; s/[<>()]//g' >> $T.s
86 disas $T
87 cat $T.dis >> $T.oo
88 rm -f $T.o $T.s $T.dis
89
90 # and fix code at-and-after marker
91 code=`echo "$code" | cut -c$((${marker} + 1))-`
92 fi
93 echo Code starting with the faulting instruction > $T.aa
94 echo =========================================== >> $T.aa
95 code=`echo $code | sed -e 's/ [<(]/ /;s/[>)] / /;s/ /,0x/g; s/[>)]$//'`
96 echo -n " .$type 0x" > $T.s
97 echo $code >> $T.s
98 disas $T
99 cat $T.dis >> $T.aa
100
101 # (lines of whole $T.oo) - (lines of $T.aa, i.e. "Code starting") + 3,
102 # i.e. the title + the "===..=" line (sed is counting from 1, 0 address is
103 # special)
104 faultlinenum=$(( $(wc -l $T.oo | cut -d" " -f1) - \
105 $(wc -l $T.aa | cut -d" " -f1) + 3))
106
107 faultline=`cat $T.dis | head -1 | cut -d":" -f2-`
108 faultline=`echo "$faultline" | sed -e 's/\[/\\\[/g; s/\]/\\\]/g'`
109
110 cat $T.oo | sed -e "${faultlinenum}s/^\(.*:\)\(.*\)/\1\*\2\t\t<-- trapping instruction/"
111 echo
112 cat $T.aa
113 cleanup